{    var   : }
{ EPS }
Unit MNB5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB5R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var DELX :Real; var EPS :Real; XLIM :Real;
                var XMIN :Real; var YMIN :Real; var KOUNT :Integer;
                var IER :Integer; FUN :Proc_F1_MN);

implementation

procedure MNB5R(N :Integer; var X :Array of Real;
                var S :Array of Real; var XX :Array of Real;
                var DELX :Real; var EPS :Real; XLIM :Real;
                var XMIN :Real; var YMIN :Real; var KOUNT :Integer;
                var IER :Integer; FUN :Proc_F1_MN);
var
I,II,JK :Integer;
CONST_,X1,X2,Y1,Y2,X3,Y3,RR,A,B,D,E,ZZT,ZZB,ZZM,YFM :Real;
ZZ :Array [0..2] of Real;
YF :Array [0..2] of Real;
label
_100,_120,_130,_140,_160,_165,_170,_180,_190,_195,_200,_220,_230,_235,
_240,_250,_260,_270,_280,_500,_510,_1000;
begin

{ -----OHOMEPHA MHMA------ }

{     AOPTM KBAPATHO APOKCMA }
{     CK - AYA }

{     APAMETP: }
{     N     -PAMEPHOCT POCTPAHCTBA }
{     X     -HAAHA TOKA }
{     S     -HAPABEHE OHOMEPHO MHMA }
{     XX    -PAO MACCB PAMEPHOCT N }
{     DELX  -HAAH A OHOMEPHOO OCKA }
{     EPS   -TOHOCT BCEH MHMYMA }
{           O YHKOHAY }
{     XLIM  -TOHOCT BCEH OHOMEPHOO }
{           MHMYMA O APYMEHTY }
{     XMIN  -PACCTOHE O TOK MHMYMA }
{            BO S }
{     YMIN  -MHMAHOE HAEHE YHK }
{            BO S }
{     KOUNT -CO BCEH YHK P }
{            OHOMEPHO MHMA }
{     IER   -PHAK OKOHAH OCKA: }
{            IER=0 -MHMYM HAEH }
{            IER=1 -MHMYM BO S HE }
{            CYECTBYET }
{     FUN   -OPOPAMMA BCEH }
{            YHK B TOKE }

CONST_ := 1.E+08;
KOUNT := 0;
X1 := 0.0;

{ ----BCEHE YHK B HA. TOKE }

for I:=1 to N do
 begin
_100:
  XX[I-1] := X[I-1];
 end;
FUN(XX,Y1,EPS);
KOUNT := KOUNT+1;
X2 := X1+DELX;
II := 0;
_120:
for I:=1 to N do
 begin
_130:
  XX[I-1] := X[I-1]+X2*S[I-1];
 end;
FUN(XX,Y2,EPS);
KOUNT := KOUNT+1;
if ( Y1 >= Y2 ) 
 then goto _140;
if ( II >= 1 ) 
 then goto _190;
II := II+1;
DELX := -DELX;

{ ----A O HAPABEH  B. YHK }

X2 := X1+DELX;
goto _120;

{     EPEAA YPABEH AOPTMY AYA }

_140:
X3 := X2+DELX;
_160:
for I:=1 to N do
 begin
_165:
  XX[I-1] := X[I-1]+X3*S[I-1];
 end;
FUN(XX,Y3,EPS);
KOUNT := KOUNT+1;
if ( Y3 < Y2 ) 
 then goto _170;
if ( DELX > 0.0 ) 
 then goto _200;
RR := X1;
X1 := X3;
X3 := RR;
RR := Y1;
Y1 := Y3;
Y3 := RR;
goto _200;

{ ----HAEHE YHK YMEHAETC. }
{     YBABAHE AA }

_170:
DELX := 2.0*DELX;
if ( DELX < CONST_ ) 
 then goto _180;
IER := 1;
goto _1000;
_180:
X2 := X3;
X3 := X2+DELX;
Y2 := Y3;
goto _160;

{            AOPTM AYA }

{ ----BCEHE HAEH YHK B }
{     TPEX TOKAX }

_190:
ZZ[0] := X2;
YF[0] := Y2;
ZZ[1] := X1;
YF[1] := Y1;
ZZ[2] := X1-DELX;
for I:=1 to N do
 begin
_195:
  XX[I-1] := X[I-1]+ZZ[2]*S[I-1];
 end;
FUN(XX,YF[2],EPS);
KOUNT := KOUNT+1;
goto _220;
_200:
ZZ[0] := X1;
ZZ[1] := X2;
ZZ[2] := X3;
YF[0] := Y1;
YF[1] := Y2;
YF[2] := Y3;
_220:
A := ZZ[1]-ZZ[2];
B := ZZ[2]-ZZ[0];
D := IntPower(ZZ[1],2)-IntPower(ZZ[2],2);
E := IntPower(ZZ[2],2)-IntPower(ZZ[0],2);

{ ----BCEHE MIN HTEPOOHHOO }
{     MHOOEHA }

ZZT := (D*(YF[0]-YF[2])+E*(YF[1]-YF[2]))/2.0;
ZZB := A*(YF[0]-YF[2])+B*(YF[1]-YF[2]);
ZZM := ZZT/ZZB;
for I:=1 to N do
 begin
_230:
  XX[I-1] := X[I-1]+ZZM*S[I-1];
 end;
FUN(XX,YFM,EPS);
KOUNT := KOUNT+1;

{ ----BOP HOBO TPOK TOEK }
{      APOKCMA }

if ( ZZM < ZZ[0] ) or ( ZZM > ZZ[2] )
 then goto _500;
if ( Abs(YFM-YF[1]) <= EPS ) 
 then goto _500;
if ( YF[1] > YFM ) 
 then goto _250;
if ( ZZ[1]-ZZM ) < 0
 then goto _235
 else if ( ZZ[1]-ZZM ) > 0
       then goto _240
       else goto _500;
_235:
JK := 3;
goto _280;
_240:
JK := 1;
goto _280;
_250:
JK := 2;
if ( ZZ[1]-ZZM ) < 0
 then goto _260
 else if ( ZZ[1]-ZZM ) > 0
       then goto _270
       else goto _500;
_260:
ZZ[0] := ZZ[1];
YF[0] := YF[1];
goto _280;
_270:
ZZ[2] := ZZ[1];
YF[2] := YF[1];
_280:
ZZ[JK-1] := ZZM;
YF[JK-1] := YFM;
if ( ZZ[2]-ZZ[0] > XLIM ) 
 then goto _220;
_500:
IER := 0;
if ( YFM < YF[1] ) 
 then goto _510;
XMIN := ZZ[1];
YMIN := YF[1];
goto _1000;
_510:
XMIN := ZZM;
YMIN := YFM;
_1000:
end;

end.
